#include "pollerRegister.h"

#include <vector>
#include <cstdio>

#include "libComAPI.h"
#include "initHooks.h"

static std::vector<std::function<void()>> registeredFunctions;

static void startPollingHook(initHookState state) {
  switch (state) {
    case initHookAtIocBuild:
      printf("\n\n\ninitHookAtIocBuild\n\n\n");      
      break;

    case initHookAtBeginning:
      printf("\n\n\ninitHookAtBeginning\n\n\n");      
      break;

    case initHookAfterCallbackInit:
      printf("\n\n\ninitHookAfterCallbackInit\n\n\n");      
      break;

    case initHookAfterCaLinkInit:
      printf("\n\n\ninitHookAfterCaLinkInit\n\n\n");      
      break;

    case initHookAfterInitDrvSup:
      printf("\n\n\ninitHookAfterInitDrvSup\n\n\n");      
      break;

    case initHookAfterInitRecSup:
      printf("\n\n\ninitHookAfterInitRecSup\n\n\n");      
      break;

    case initHookAfterInitDevSup:
      printf("\n\n\ninitHookAfterInitDevSup\n\n\n");      
      break;

    case initHookAfterInitDatabase:
      printf("\n\n\ninitHookAfterInitDatabase\n\n\n");      
      break;

    case initHookAfterFinishDevSup:
      printf("\n\n\ninitHookAfterFinishDevSup\n\n\n");      
      break;

    case initHookAfterScanInit:
      printf("\n\n\ninitHookAfterScanInit\n\n\n");      
      break;

    case initHookAfterInitialProcess:
      printf("\n\n\ninitHookAfterInitialProcess\n\n\n");      
      break;

    case initHookAfterCaServerInit:
      printf("\n\n\ninitHookAfterCaServerInit\n\n\n");      
      break;

    case initHookAfterIocBuilt:
      printf("\n\n\ninitHookAfterIocBuilt\n\n\n");      
      break;

    case initHookAtIocRun:
      printf("\n\n\ninitHookAtIocRun\n\n\n");      
      break;

    case initHookAfterDatabaseRunning:
      printf("\n\n\ninitHookAfterDatabaseRunning\n\n\n");      
      break;

    case initHookAtEnd:
      printf("\n\n\ninitHookAtEnd\n\n\n");
      break;

    case initHookAfterCaServerRunning:
      printf("\n\n\ninitHookAfterCaServerRunning\n\n\n");
      break;

    case initHookAfterIocRunning:
      printf("\n\n\ninitHookAfterIocRunning\n\n\n");      
      for(auto&& fn : registeredFunctions)
          fn();
      break;

    default:
      break;
  }
}

static int myHookStatus = initHookRegister(startPollingHook);

void registerFunction(std::function<void()> func) {
  registeredFunctions.push_back(func);
}
